(function( lui, $, undefined ){
    $(document).ready(function(){
        $('.tabLink').click(lui.tabClick);
    });

    lui.tabClick = function( evt ) {
        lui.tabChange( $(this).attr('href') );
        return false;
    }

    lui.tabChange = function( tab ) {
        if ( tab == undefined) {
            return false;
        }
        if ( tab[0] != '#' ) tab = '#' + tab;
        var scope = $('.tabLink[href="' + tab + '"]');
        if (scope.parent().hasClass('active')) return false;
        scope.parent().siblings('.active').toggleClass('active');
        scope.parent().toggleClass('active');
        $(tab).siblings('.active').toggleClass('active');
        $(tab).toggleClass('active');
        return true;
    }
}( window.lui = window.lui || {}, window.jQuery ));

(function( dswp, $, lui, undefined ){
    var bindedKeys = {};

    var keyToQKey = {
        "esc":          "TESTINGTHIS",
        "f1":           "f1",
        "f2":           "f2",
        "f3":           "f3",
        "f4":           "f4",
        "f5":           "f5",
        "f6":           "f6",
        "f7":           "f7",
        "f8":           "f8",
        "f9":           "f9",
        "f10":          "f10",
        "f11":          "f11",
        "f12":          "f12",
        "n1":           "1",
        "n2":           "2",
        "n3":           "3",
        "n4":           "4",
        "n5":           "5",
        "n6":           "6",
        "n7":           "7",
        "n8":           "8",
        "n9":           "9",
        "n0":           "0",
        "num0":         "KP_INS",
        "numnum":       "KP_NUMLOCK",
        "numsl":        "KP_SLASH",
        "numst":        "KP_STAR",
        "num7":         "KP_HOME",
        "num8":         "KP_UPARROW",
        "num9":         "KP_PGUP",
        "numpl":        "KP_PLUS",
        "num4":         "KP_LEFTARROW",
        "num5":         "KP_5",
        "num6":         "KP_RIGHTARROW",
        "num1":         "KP_END",
        "num2":         "KP_DOWNARROW",
        "num3":         "KP_PGDN",
        "numen":        "KP_ENTER",
        "tab":          "TAB",
        "q":            "q",
        "w":            "w",
        "e":            "e",
        "r":            "r",
        "t":            "t",
        "z":            "z",
        "u":            "u",
        "i":            "i",
        "o":            "o",
        "p":            "p",
        "plus":         "+",
        "lock":         "CAPSLOCK",
        "a":            "a",
        "s":            "s",
        "d":            "d",
        "f":            "f",
        "g":            "g",
        "h":            "h",
        "j":            "j",
        "k":            "k",
        "l":            "l",
        "ns":           "#",
        "sshift":       "SHIFT",
        "la":           "<",
        "y":            "y",
        "x":            "x",
        "c":            "c",
        "v":            "v",
        "b":            "b",
        "n":            "n",
        "m":            "m",
        "komma":        ",",
        "dot":          ".",
        "minus":        "-",
        "uparrow":      "UPARROW",
        "downarrow":    "DOWNARROW",
        "leftarrow":    "LEFTARROW",
        "rightarrow":   "RIGHTARROW",
        "ctrl":         "CTRL",
        "sspace":       "SPACE",
        "aalt":         "ALT",
        "del":          "KP_DEL",
        "num0":         "KP_INS",
    }

    var imageSizes = {};
    var fovImg = {};
    imageSizes[90] = [966, 546];
    imageSizes[100] = [1140, 638];
    imageSizes[110] = [1366, 768];

    /*
    document.addEventListener('keydown', function(event) {
        console.log('event.keyCode: ' + event.keyCode + ' event.which: ' + event.which);
    }, true);
    */
    $(document).ready(function(){
        $('.keyButton').click(dswp.clickKey);

        initFov();
    })

    dswp.bindKey = function() {
        var activeKey = $('.keyActive');
        if (activeKey.length == 0) return;
        var tab = $('.keyEditor .tabContent.active').attr('id');
        switch (tab) {
            case 'tabBindRadio':
                bindedKeys[activeKey.val()] = {
                    'tab': tab,
                    'consoleString': 'bind ' + keyToQKey[activeKey.val()] + ' "' + $('.keyEditor select[name="radioSelectName"]').val() + ' ' + $('.keyEditor textarea[name="radioTextName"]').val() + '"' + '\n',
                    'formData': {
                        'textarea[name="radioTextName"]': $('.keyEditor textarea[name="radioTextName"]').val(),
                        'select[name="radioSelectName"]': $('.keyEditor select[name="radioSelectName"]').val()
                    }
                };
                break;
            case 'tabBindCustom':
                bindedKeys[activeKey.val()] = {
                    'tab': tab,
                    'consoleString': 'bind ' + keyToQKey[activeKey.val()] + ' "' + $('.keyEditor textarea[name="customBindName"]').val() + '"\n',
                    'formData': {
                        'textarea[name="customBindName"]': $('.keyEditor textarea[name="customBindName"]').val(),
                    }
                };
                break;
        }
        
        activeKey.toggleClass('keyBinded',true);
        dswp.consoleRefresh();
    }

    dswp.unbindKey = function() {
        var activeKey = $('.keyActive');
        if (activeKey.length == 0) return;
        if (typeof bindedKeys[activeKey.val()] == 'undefined') return;
        activeKey.toggleClass('keyBinded',false);
        delete bindedKeys[activeKey.val()];
        $('.keyEditorForm')[0].reset();
        dswp.consoleRefresh();
    }

    dswp.clickKey = function() {
        var activated = $('.keyActive');
        if ($(this) != activated) {
            activated.toggleClass('keyActive');
            $(this).toggleClass('keyActive');
            if (typeof bindedKeys[$(this).val()] != 'undefined') {
                loadKeyForm($(this).val());
            } else {
                $('.keyEditorForm')[0].reset();
            }
        }
    }

    function loadKeyForm( keyVal ) {
        lui.tabChange(bindedKeys[keyVal].tab);
        for (var prop in bindedKeys[keyVal].formData) {
            $('#' + bindedKeys[keyVal].tab + ' ' + prop).val(bindedKeys[keyVal].formData[prop]);
        }
    }

    dswp.consoleRefresh = function() {
        var consoleOutput = $('#consoleOutputId')[0];
        consoleOutput.value = '';
        for (var keyBind in bindedKeys) {
            consoleOutput.value += bindedKeys[keyBind].consoleString;
        }
    }

    dswp.colorSelect = function() {
        sayv = $('.keyEditor textarea[name="radioTextName"]').val();
        $('.keyEditor textarea[name="radioTextName"]').val(sayv + $('#colorSelectId').val());
    }

    dswp.refreshFov = function() {
        if (($('#fov_enter').val() < 90) || ($('#fov_enter').val() > 110)) return;
        $('#fov_for_console')[0].value = "cg_fov " + $('#fov_enter').val();
        var imageSize = getFovImageSize($('#fov_enter').val());
        var imageWidth = imageSize[0] * fovImg.scale;
        var imageHeight = imageSize[1] * fovImg.scale;
        var wrapperEl = document.querySelector('.fovWrapper');
        var containerEl = document.querySelector('.fovContainer');
        var cutterEl = document.querySelector('.fovCutter');
        var fovToImgScale = (cutterEl.offsetWidth / imageWidth);
        imageWidth = fovImg.width * fovToImgScale;
        imageHeight = fovImg.height * fovToImgScale;
        wrapperEl.style.width = imageWidth + "px";
        wrapperEl.style.height = imageHeight + "px";
        wrapperEl.style.marginTop = ( parseInt(containerEl.style.height) - imageHeight ) / 2 + "px";
    }

    function getFovImageSize( fov ) {
        fov = parseInt(fov);
        var lastImageFov = 0;
        var width = 0;
        var height = 0;
        var imageSize = [];
        var lastImageSize = [];
        for (var imageFov in imageSizes) {
            imageFov = parseInt(imageFov);
            imageSize = imageSizes[imageFov];
            if (imageFov == fov) {
                return [imageSize[0], imageSize[1]];
            }
            if (imageFov > fov) {
                lastImageSize = imageSizes[lastImageFov];
                width = lastImageSize[0] + (imageSize[0] - lastImageSize[0]) / (imageFov - lastImageFov) * (fov - lastImageFov);
                height = lastImageSize[1] + (imageSize[1] - lastImageSize[1]) / (imageFov - lastImageFov) * (fov - lastImageFov);
                return [width, height];
            }
            lastImageFov = imageFov;
        }
        //The fov is less than 90 or more than 110
        return imageSizes[110];
    }

    function initFov() {
        var imgEl = document.querySelector('.fovCutter img');
        var cutterEl = document.querySelector('.fovCutter');
        var containerEl = document.querySelector('.fovContainer');
        var wrapperEl = document.querySelector('.fovWrapper');
        fovImg.scale = cutterEl.offsetWidth / imageSizes[90][0];
        fovImg.width = imgEl.offsetWidth * fovImg.scale;
        fovImg.height = imgEl.offsetHeight * fovImg.scale;
        cutterEl.style.height = fovImg.height / fovImg.width * cutterEl.offsetWidth + "px";
        imgEl.style.width = "100%";
        imgEl.style.height = "100%";
        containerEl.style.width = fovImg.width + "px";
        containerEl.style.height = fovImg.height + "px";
        containerEl.style.left = "-" + (fovImg.width - cutterEl.offsetWidth) / 2 + "px";
        containerEl.style.top = "-" + (fovImg.height - cutterEl.offsetHeight) / 2 + "px";
        wrapperEl.style.width = fovImg.width + "px";
        wrapperEl.style.height = fovImg.height + "px";
    }
}( window.dswp = window.dswp || {}, window.jQuery, window.lui ));
